uniform sampler2DArray tex0;

void main() {
	vec4 col;
    vec4 light;
    float ambient = 0.200000;
	vec4 lightDirection = vec4(1.0, 0.7, 1.0, 0.0);
	float ldn;
	vec3 coord = gl_TexCoord[1].xyz/16;
	coord = cross(coord, gl_TexCoord[0].xyz);
	float material = floor(gl_TexCoord[1].w);
	vec3 a, b, c; // axis of plane
	a = normalize(gl_TexCoord[0].xyz); // normal
	b = normalize(vec3(a.y, -a.x, 0.0));
	if(b.x == 0 && b.y == 0) {
		b = normalize(vec3(0.0, a.z, -a.y));
	}
	c = normalize(cross(a, b));
	coord = inverse(mat3(a,b,c)) * coord;
	vec2 tex;
	tex.x = coord.y;
	tex.y = coord.z;

	vec3 texCoord = vec3(tex.xy, material);
	col = texture2DArray( tex0, texCoord);

    light = -normalize( lightDirection );
    ldn = max( 0.000000, dot( light, gl_TexCoord[0]));
    gl_FragData[0] = vec4( col * (ambient + ldn*(1-ambient)) );
}
